SystemOrganization addCategory: #'RecentSubmissions-Core'!
SystemOrganization addCategory: #'RecentSubmissions-UI'!

MorphTreeNodeModel subclass: #MessageListAbstractNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListAbstractNode commentStamp: '<historical>' prior: 0!
A MessageListAbstractNode is an abstract node model.
Instance Variables
!

!MessageListAbstractNode methodsFor: 'comparing' stamp: 'AlainPlantec 2/13/2011 17:46'!
= anotherNode

	anotherNode species = self species
		ifTrue: [^ self item = anotherNode item]
		ifFalse: [^ false].! !

!MessageListAbstractNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
doubleClick

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 20:29'!
environment

	self model 
		ifNotNil: [:m| ^m environment].
	self error: 'The model should probably not be nil'! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
getClass

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
includes: aNode
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
inspectableContents
	
	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
isInspectable

	^self subclassResponsibility
! !

!MessageListAbstractNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
isMethod

	^ self item isMethod.! !

!MessageListAbstractNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
originalIndex

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'action' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
printList: aStream

	^self subclassResponsibility! !

!MessageListAbstractNode methodsFor: 'action' stamp: 'BenjaminVanRyseghem 11/29/2010 11:08'!
removeMe
	
	^self subclassResponsibility! !

MessageListAbstractNode subclass: #MessageListInspectableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'VeronicaUquillas 8/31/2011 23:51'!
asString
	^ self item ifNotNil: [self item fullName ] ! !

!MessageListInspectableNode methodsFor: 'overrided' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
doubleClick

	self item browse! !

!MessageListInspectableNode methodsFor: 'accessing' stamp: 'VeronicaUquillas 9/3/2011 20:14'!
getClass

	^self item realClass! !

!MessageListInspectableNode methodsFor: 'testing' stamp: ''!
includes: aNode

	^ self = aNode complexContents.! !

!MessageListInspectableNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:48'!
inspectableContents

	^ OrderedCollection with: self! !

!MessageListInspectableNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
isInspectable

	^true! !

!MessageListInspectableNode methodsFor: 'accessing' stamp: ''!
originalIndex

	^self model originalIndex: (self item)! !

!MessageListInspectableNode methodsFor: 'action' stamp: 'VeronicaUquillas 9/3/2011 20:12'!
printList: aStream
	
	aStream nextPutAll: self item fullName! !

MessageListAbstractNode subclass: #MessageListNonInspectableNode
	instanceVariableNames: 'dictionary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'AlainPlantec 2/13/2011 20:18'!
asString
	^ self item
		ifNotNil: [self level = 1
				ifTrue: [self model level = 2
						ifTrue: [self item name asString]
						ifFalse: [self model level = 3
								ifTrue: [self item asString]]]
				ifFalse: [self item name asString]] ! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
childNodeClassFromItem: anItem

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^MessageListInspectableNode].
			self model level = 3
				ifTrue:[^self class]]
		ifFalse: [^MessageListInspectableNode]
! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: ''!
childrenItems

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^self dictionary at: self item].
			self model level = 3
				ifTrue:[^self dictionary  keys]]
		ifFalse: [^self dictionary at: self item]

! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
dictionary

	dictionary ifNil: [
		self parentNode isNil
			ifTrue:  [
				self model level = 2
					ifTrue: [dictionary := self model dictionary].
				self model level = 3
					ifTrue:[dictionary := self model dictionary at: self item]]
			ifFalse: [dictionary := self model dictionary at: (self parentNode item)]].
	^dictionary! !

!MessageListNonInspectableNode methodsFor: 'overrided' stamp: 'IgorStasenko 3/6/2011 18:55'!
doubleClick

	| class |
	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[class := self getClass].
			self model level = 3
				ifTrue:[class := (self childNodeFromItem: (self childrenItems first)) getClass]]
		ifFalse: [
			class := self getClass].
		Smalltalk tools browse: class selector: nil
	! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
getClass

	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue:[^self item].
			self model level = 3
				ifTrue:[^self error: 'You shouldn''t ask the class of a package']]
		ifFalse: [^self item]! !

!MessageListNonInspectableNode methodsFor: 'testing' stamp: 'AlainPlantec 2/13/2011 19:35'!
includes: aNode 
	^ self = aNode complexContents | (self contents
			detect: [:each | each includes: aNode]
			ifNone: []) notNil ! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:49'!
inspectableContents

	| result |
	result := OrderedCollection new.
	self contents 
		do: [:each | result addAll: each inspectableContents].
	^ result.! !

!MessageListNonInspectableNode methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
isInspectable

	^false! !

!MessageListNonInspectableNode methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
originalIndex

	| methodReference |
	self level = 1
		ifTrue: [
			self model level = 2
				ifTrue: [methodReference := (self childrenItems first)].
			self model level = 3
				ifTrue: [ methodReference := (self dictionary associations first value first).]]
		ifFalse: [
			methodReference := (self childrenItems first)].
	^self model originalIndex: methodReference
	! !

!MessageListNonInspectableNode methodsFor: 'action' stamp: 'BenjaminVanRyseghem 11/29/2010 11:18'!
printList: aStream

	| tab |
	tab := '- '.
	aStream 
		nextPutAll: self item asString;
		nextPutAll: ' :'.
	self contents do: [:each | 
			aStream nextPutAll: '
'.
			aStream nextPutAll: tab.
			each printList: aStream]
! !

!MessageListNonInspectableNode methodsFor: 'action' stamp: ''!
removeMe

	self contents do: [:each | each removeMe].! !

!ChangeRecord methodsFor: '*RecentSubmissions-Core' stamp: 'BenjaminVanRyseghem 5/6/2011 17:39'!
<= anotherOne

	self stamp ifNil: [ ^ false ].
	anotherOne stamp ifNil: [ ^ true ].
	^ self timeStamp <= anotherOne timeStamp ! !

!ChangeRecord methodsFor: '*RecentSubmissions-Core' stamp: 'BenjaminVanRyseghem 5/6/2011 17:48'!
printOn: aStream

	aStream 
		nextPutAll: self type printString.
	self stamp ifNotNil: [ aStream nextPutAll: self stamp ]! !

!ChangeRecord methodsFor: '*RecentSubmissions-Core' stamp: 'BenjaminVanRyseghem 5/9/2011 15:44'!
sourceCode
	
	self type= #preamble ifTrue: [ ^ #preamble printString ].
	self type= #doIt ifTrue: [ ^ #preamble printString ].
	self type= #classComment ifTrue: [ self commentClass ifNotNil: [ :comment | ^ comment comment ]].

	self methodClass ifNil: [ ^ '' ].
	^ (self methodClass >> self methodSelector) getSource! !

MorphTreeModel subclass: #MessageListBrowser
	instanceVariableNames: 'model textArea preference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!MessageListBrowser commentStamp: 'BenjaminVanRyseghem 8/31/2010 01:43' prior: 0!
MessageListBrowser is the UI for instances of MessageList

Instance Variables:
	messageList	<Object>
	dictionary	<BrowserEnvironment | Dictionary | OpenFileStreamRegistry | RBSmallDictionary | SharedPool class | SmallDictionary | SmalltalkImage | WeakRegistry>
	originalList	<ProtoObject | PseudoContext>
	selectedMorph	<Object>
	treeMorph	<MorphTreeMorph>
	textArea	<CodeMorph | OBPluggableTextMorphWithShout | PluggableShoutMorph | PluggableTextMorphPlus>
	dropList	<ProtoObject | PseudoContext>
	preference	<Object>
	sortingSelector	<ProtoObject | PseudoContext>!

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byClassOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byClassSelector! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byDateAscendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateAscendingSelector! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
byDateDescendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateDescendingSelector.! !

!MessageListBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 11/29/2010 10:23'!
on: aMessageList
	^self new model: aMessageList
	! !

!MessageListBrowser class methodsFor: 'deprecated' stamp: 'StephaneDucasse 11/26/2010 16:58'!
on: aMessageList groupedUsing: aSelector
	
	| association |
	association := (aMessageList perform: aSelector).
	^self new
		messageList: aMessageList;
		dictionary:  association key;
		originalList: association value.

	! !

!MessageListBrowser methodsFor: 'items addition' stamp: 'AlainPlantec 2/13/2011 17:23'!
addAllItems: aWindow

	| width toolbar btnFont |	
	toolbar := self buildToolbar: aWindow.
	btnFont := StandardFonts buttonFont.
	aWindow
		addMorph: (self treeMorph buildContents; yourself)
		fullFrame: (LayoutFrame
			fractions: (0@0 corner: 1@0.5)
			offsets:(0@0 corner:0@0)).
	aWindow
		addMorph: toolbar
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@0.5)
			offsets:(0@0 corner:0@(btnFont height + 14))).
			
	self textArea: self buildTextArea.
	
	aWindow
		addMorph: self textArea
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@1)
			offsets:(0@(btnFont height + 14) corner:0@0)).! !

!MessageListBrowser methodsFor: 'items addition' stamp: ''!
addTextArea: aWindow

	aWindow 
		addMorph: self textArea 
		frame: (0@0.5 corner: 1@1).	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonAction 

	self browseSelectedMorph! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
browseButtonLabel

	^'Browse'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:22'!
browseButtonState 

	^self selectedItem isNil.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'AlainPlantec 2/13/2011 15:30'!
browseSelectedMorph

	self selectedNode ifNotNil: [ :node | node doubleClick].! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonBrowse
	
	^(PluggableButtonMorph 
		on: self 
		getState: #browseButtonState 
		action: #browseButtonAction 
		label: #browseButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonClear
	
	^(PluggableButtonMorph 
		on: self 
		getState: #clearButtonState 
		action: #clearButtonAction 
		label: #clearButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
buildButtonRemove
	
	^(PluggableButtonMorph 
		on: self 
		getState: #removeButtonState 
		action: #removeButtonAction 
		label: #removeButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
buildButtonRevert
	
	^(PluggableButtonMorph 
		on: self 
		getState: #revertButtonState 
		action: #revertButtonAction 
		label: #revertButtonLabel)
		hResizing: #spaceFill! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'FernandoOlivero 4/12/2011 09:55'!
buildDisplayDropList: aWindow

	^( self theme   
		newDropListIn: aWindow
		for:self				
		list: #getDisplayList
		getSelected: #sortingSelector
		setSelected: #sortingSelector:
		getEnabled: nil
		useIndex: false 
		help: self sortingSelectorHelpText) hResizing: #rigid; width: 150; yourself
! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'FernandoOlivero 4/12/2011 09:54'!
buildPreferenceDropList: aWindow

	^( self theme  
		newDropListIn: aWindow
		for:self				
		list: #getPreferencesList
		getSelected: #preference
		setSelected: #preference:
		getEnabled: nil
		useIndex: false 
		help: self preferenceHelpText) hResizing: #rigid; width: 150; yourself! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'AlainPlantec 8/26/2011 17:46'!
buildTextArea

	| text |
	text := self textMorphClass 
		on: self
		text: #textToDisplay
		accept: #compileMethod:
		readSelection: nil
		menu: #msgPaneMenu:shifted:.
	text 
		visible: false;
		askBeforeDiscardingEdits: true.
	^ text! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/13/2011 13:36'!
buildToolbar: aWindow
	"create the buttons toolbar"
	
	| toolbar |
	toolbar := aWindow newToolbar: {
		self buildDisplayDropList: aWindow.
		self buildButtonBrowse.
		self buildButtonRevert.
		self buildButtonRemove.
		self buildButtonClear.
		self buildPreferenceDropList: aWindow.}.
	^toolbar hResizing: #shrinkWrap! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byClassLabel

	^'By Class'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byDateAscendingLabel

	^'By Date Ascending'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byDateDescendingLabel

	^'By Date Descending'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byPackageLabel

	^'By Package'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:12'!
byVersionLabel

	^'By Version'! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
byteCodeLabel

	^'Byte Code'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:09'!
clearButtonAction

	self promptForClear
		ifTrue: [self model clearAll]! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
clearButtonLabel

	^'Clear List'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/11/2011 16:44'!
clearButtonState 

	^self model dictionary isEmpty.! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/16/2011 13:56'!
compileMethod: aString

	| method class |
	self textArea hasUnacceptedEdits: false.
	method := self 
				getMethod: self selectedNode
				ifAbsent: ["use the information from the tree"
					class := self selectedNode getClass.
					nil].
	method ifNotNil: [:m | class := m methodClass].
	class compile: aString.
	self changed: #textToDisplay.! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/10/2011 14:39'!
dictionary

	| result |
	result := self model dictionary.
	result ifEmpty: [self selection: nil].
	^result! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
diffLabel

	^'Diffs'! !

!MessageListBrowser methodsFor: 'text' stamp: 'MarcusDenker 4/29/2011 00:36'!
displayIfByteCode: aMessageListInspectableNode

	 | method |
	method := self getMethod: aMessageListInspectableNode ifAbsent: [nil].
	method ifNotNil: [ :each | ^each method symbolic ].
	^self unvailableByteCodeLabel! !

!MessageListBrowser methodsFor: 'text' stamp: 'StephaneDucasse 7/26/2011 14:19'!
displayIfDiff: aMessageListInspectableNode

	| methodReference |
	methodReference := aMessageListInspectableNode item.
	^TextDiffBuilder
		 buildDisplayPatchFrom: ((self model priorVersionOfAMethod: methodReference) sourceCode) 
		to: (methodReference sourceCode) 
		inClass: (methodReference className)! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 1/20/2011 15:54'!
displayIfInfo: aMessageListInspectableNode

	^ 'Last modification : 
		', (aMessageListInspectableNode item timeStamp asDateAndTime asTimeStamp asString)
! !

!MessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 8/27/2011 14:47'!
displayIfSource: aMessageListInspectableNode

		^ aMessageListInspectableNode item sourceCode.! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
displayIfVersion: aMessageListInspectableNode

	^'Version ', (self model versionOfAMethod: aMessageListInspectableNode item) asString! !

!MessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 8/26/2011 17:55'!
displayInformationFrom: aMessageListInspectableNode

	self preference = self sourceLabel
		ifTrue: [^ self displayIfSource: aMessageListInspectableNode].
	self preference = self byteCodeLabel
		ifTrue: [^ self displayIfByteCode: aMessageListInspectableNode].
	self preference = self infoLabel
		ifTrue: [	^ self displayIfInfo: aMessageListInspectableNode].
	self preference = self versionLabel
		ifTrue:[ ^self displayIfVersion: aMessageListInspectableNode].
	self preference = self diffLabel 
		ifTrue: [^ self displayIfDiff: aMessageListInspectableNode].
	^ self error: 'Error in the drop list'! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
doubleClick

	self selectedNode ifNotNil: [:n | n doubleClick]! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:32'!
emptySelection
	
	self selection: nil! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
environment

	^ self model environment! !

!MessageListBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:45'!
format: aString

	| list size result |
	size := 0.
	list := aString subStrings: String cr.
	list do: [:line || addedCharacter tempSize|
		addedCharacter := ''.
		line first == $- ifTrue: [addedCharacter := '	'].
		tempSize := (addedCharacter, line) size.
		(tempSize > size) ifTrue: [size := tempSize]]! !

!MessageListBrowser methodsFor: 'droplist' stamp: ''!
getDisplayList

	^OrderedCollection new
		add: self byClassLabel;
		add: self byVersionLabel;
		add: self byDateAscendingLabel;
		add: self byDateDescendingLabel;
		add: self byPackageLabel;
		yourself.
! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
getMethod: aMessageListInspectableNode

	| methodReference |
	methodReference := (self getMethodReference: aMessageListInspectableNode) .
	^ methodReference compiledMethod.
	! !

!MessageListBrowser methodsFor: 'tree' stamp: 'VeronicaUquillas 9/3/2011 20:25'!
getMethod: aMessageListInspectableNode ifAbsent: aBlock

	| methodReference |
	methodReference := (self getMethodReference: aMessageListInspectableNode) .
	^ methodReference realClass methodDict
			at: methodReference name
			ifAbsent: aBlock.
	! !

!MessageListBrowser methodsFor: 'tree' stamp: ''!
getMethodReference: aMessageListInspectableNode

	^aMessageListInspectableNode item.! !

!MessageListBrowser methodsFor: 'droplist' stamp: ''!
getPreferencesList

	^OrderedCollection new
		add: self sourceLabel;
		add: self byteCodeLabel;
		add: self diffLabel;
		add: self versionLabel;
		add: self infoLabel;
		yourself.
! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
infoLabel

	^'Change Date'! !

!MessageListBrowser methodsFor: 'initialization' stamp: 'AlainPlantec 2/13/2011 17:31'!
initialize
	super initialize.
	self preference: self getPreferencesList first.
! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 15:28'!
isComment
	| node |
	node := self selectedNode.
	^(node isInspectable) & (node item = 'Comment'). ! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:16'!
level

	^ self model level.! !

!MessageListBrowser methodsFor: 'menus' stamp: 'AlainPlantec 2/13/2011 17:20'!
menu: menu shifted: b 

	menu
		add: 'Browse' translated
		target: self
		selector: #browseSelectedMorph.
	menu
		add: 'Remove'
		target: self
		selector: #removeSelectedMorph.
	menu
		add: 'Expand All'
		target: self 
		selector: #expandAll.
	menu
		add: 'Collapse All'
		target: self 
		selector: #collapseAll..
	^menu! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:22'!
model

	^model! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'AlainPlantec 2/13/2011 17:27'!
model: aModel

	model := aModel.
	model
		when: #changed
		send: #updateView
		to: self.
! !

!MessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
msgPaneMenu: aMenu shifted: shifted

	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!MessageListBrowser methodsFor: 'display' stamp: 'AlainPlantec 2/13/2011 17:29'!
openInWorld
	| win |
	win := StandardWindow new model: self.
	win title: self model title.
	self addAllItems: win.
	win themeChanged.
	win openInWorld.
	^ win! !

!MessageListBrowser methodsFor: 'tree' stamp: 'BenjaminVanRyseghem 11/29/2010 11:17'!
originalIndex: aMethodeReference
	"must respect the original order because the dictionary is automaticaly sorted"

	| tempList |
	tempList := self originalList.
	
	1 to: (tempList size) do:[:i |
			(tempList at: i) == aMethodeReference
				ifTrue: [^i]].
	self error: 'Index not found'.
	^0! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
originalList

	^ self model sortedMethodReferencesList! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
preference

	^ preference! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 13:57'!
preference: anObject

	preference := anObject.
	self changed: #textToDisplay.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
preferenceHelpText

	^'Choose way to show'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
promptForClear
	"Ask if it is OK to remove all the nodes"
	
	^(self confirm: 'Do you really want to clear the list ?' translated)
					
	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:46'!
promptForRemove: aNode
	"Ask if it is OK to remove the node"
	
	| list |
	
	list := WriteStream on: ''.
	list nextPutAll: 'Are you sure you want to remove :
'.
	aNode printList: list.
	list nextPutAll: ' ?'.
	self format: list contents.

	
	^(self confirm: list contents translated)
					
	! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonAction 

	self removeSelectedMorph! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
removeButtonLabel

	^'Remove'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:24'!
removeButtonState 

	^self selectedItem isNil.! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:28'!
removeSelectedMorph
	self selectedNode ifNotNil: [:n | 
		(self promptForRemove: n)
			ifTrue: [n removeMe]]! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
revertButtonAction 

	(self revertButtonState not and: [self textArea hasUnacceptedEdits not])
		ifTrue: [self compileMethod: self textArea getText asString.]
		ifFalse: [ExampleBuilderMorph new alert: 'The source code must have not been modified']! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 11/29/2010 11:10'!
revertButtonLabel

	^'Revert'! !

!MessageListBrowser methodsFor: 'buttons behavior' stamp: 'AlainPlantec 2/13/2011 15:29'!
revertButtonState 

	^self selectedNode notNil and: [self selectedNode isInspectable not]
! !

!MessageListBrowser methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 10:23'!
rootItems

	self model useAsASet
		ifTrue: [^ self originalList]
		ifFalse: [^self dictionary keys select: [:each | each isNil not]] "with some test, the class may be nil oO"
	! !

!MessageListBrowser methodsFor: 't - accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:14'!
rootNodeClassFromItem: anItem
	"the class used to build node"
	
	^self model useAsASet 
		ifTrue:[MessageListInspectableNode]
		ifFalse: [MessageListNonInspectableNode]! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 13:57'!
selection: aSelection
	super selection: aSelection.
	self changed: #textToDisplay.
	self updateTextArea
! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:40'!
sortingSelector

	self model isSortedByClass
		ifTrue: [	^ self byClassLabel].
	self model isSortedByDateAscending
		ifTrue: [	^ self byDateAscendingLabel].
	self model isSortedByDateDescending
		ifTrue: [	^ self byDateDescendingLabel].
	self model isSortedByPackage
		ifTrue: [	^ self byPackageLabel].
	self model isSortedByVersion
		ifTrue: [	^ self byVersionLabel].! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
sortingSelector: anObject

	anObject = self byClassLabel
		ifTrue: [	self model groupedByClass ].
	anObject = self byDateAscendingLabel
		ifTrue: [	self model groupedByDateAscending ].
	anObject = self byDateDescendingLabel
		ifTrue: [	self model groupedByDateDescending ].
	anObject = self byPackageLabel
		ifTrue: [	self model groupedByPackage ].
	anObject = self byVersionLabel
		ifTrue: [	self model groupedByVersion ].
	self updateView.! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
sortingSelectorHelpText

	^'Set the way to sort items'
! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
sourceLabel

	^'Source'! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
textArea

	^ textArea! !

!MessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:11'!
textArea: anObject

	textArea := anObject! !

!MessageListBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/5/2011 14:04'!
textMorphClass

	^ PluggableTextMorph! !

!MessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 2/13/2011 15:31'!
textToDisplay
	
	self selectedNode isNil 
		ifFalse: [
			self selectedNode isInspectable 
				ifTrue: [^self displayInformationFrom: self selectedNode]].
	^nil! !

!MessageListBrowser methodsFor: 'items creation' stamp: 'AlainPlantec 2/13/2011 17:22'!
treeMorph
	^ (MorphTreeMorph on: self)
				doubleClickSelector: #doubleClick;
				autoDeselection: true;
				autoMultiSelection: false;
				beSingle;
				rowInset: 4;
				columnInset: 4;
				getMenuSelector: #menu:shifted:;
				sortingSelector: #originalIndex;
				rowColorForEven: Color lightGray muchLighter odd: Color white
! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 11/29/2010 11:15'!
unvailableByteCodeLabel

	^'Byte code unavailable for this object'! !

!MessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/11/2011 16:45'!
updateTextArea

	self textArea ifNil: [^self].
	(self selectedNode isNil)
		ifTrue:  [self textArea visible: false]
		ifFalse: [
			(self selectedNode isInspectable)
				ifTrue: [self textArea visible: true]
				ifFalse: [self textArea hide]]! !

!MessageListBrowser methodsFor: 'display' stamp: 'AlainPlantec 2/13/2011 15:42'!
updateTree
	| prevSelected |
	prevSelected := self selectedItem.
	self changed: #rootNodes.
	prevSelected ifNotNil: [self selectItems: prevSelected]
! !

!MessageListBrowser methodsFor: 'display' stamp: 'AlainPlantec 2/13/2011 15:42'!
updateView
	self changed: #dictionary.
	self changed: #originalList.
	self model reSort.
	self updateTree
! !

!MessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 11/29/2010 11:13'!
versionLabel

	^'Version'! !

AbstractTool subclass: #FlatMessageListBrowser
	instanceVariableNames: 'model textArea preference selectedItem forceAlphabeticalOrder title searchedString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-UI'!

!FlatMessageListBrowser commentStamp: 'StephaneDucasse 8/2/2011 22:38' prior: 0!
I'm a new UI which display info using a list instead of a tree. Due to that, I'm faster to display lists of senders and implementors.

self example!

!FlatMessageListBrowser class methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
byClassOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byClassSelector! !

!FlatMessageListBrowser class methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
byDateAscendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateAscendingSelector! !

!FlatMessageListBrowser class methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
byDateDescendingOn: aMessageList

	^self 
		on: aMessageList 
		groupedUsing: aMessageList byDateDescendingSelector.! !

!FlatMessageListBrowser class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 5/6/2011 15:25'!
example
	"self example"

	| ml mlb |
	ml := MessageList new.
	(SystemNavigation new allCallsOn: #printOn:) do: [:each | 
		ml addMethodReference: each ].

	mlb := self on: ml named: ('Senders of #printOn: [', ml size printString,']').

	mlb openInWorld! !

!FlatMessageListBrowser class methodsFor: 'compatibility with stringHolder' stamp: 'StephaneDucasse 5/28/2011 11:39'!
isPseudoSelector: aSelector
	"Answer whether the given selector is a special marker"
	self flag: #toRemoveWhenStringHolderIsGone.
	^ #(Comment Definition Hierarchy) includes: aSelector! !

!FlatMessageListBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
on: aMessageList
	^self new model: aMessageList
	! !

!FlatMessageListBrowser class methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 5/2/2011 14:05'!
on: aMessageList groupedUsing: aSelector
	
	| association |
	association := (aMessageList perform: aSelector).
	^self new
		model: aMessageList

	! !

!FlatMessageListBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/3/2011 11:32'!
on: aMessageList named: aString
	^self new 
		model: aMessageList;
		title: aString! !

!FlatMessageListBrowser class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 5/27/2011 15:23'!
on: aMessageList named: aString autoSelect: aSelector

	^self new 
		model: aMessageList;
		title: aString;
		searchedString: aSelector! !

!FlatMessageListBrowser class methodsFor: 'tool registry' stamp: 'StephaneDucasse 9/17/2011 13:39'!
openMessageList: messageList name: aString autoSelect: aSelector
	" Tool registry compitibility "

	| ml |
	ml := MessageList new methodReferenceList: messageList.
	(self on: ml named: aString autoSelect: aSelector) openInWorld! !

!FlatMessageListBrowser class methodsFor: 'tool registry' stamp: 'StephaneDucasse 9/17/2011 11:19'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry register: self as: #messageList
! !

!FlatMessageListBrowser methodsFor: 'items addition' stamp: 'BenjaminVanRyseghem 5/2/2011 13:49'!
addAllItems: aWindow

	| width toolbar btnFont |	
	toolbar := self buildToolbar: aWindow.
	btnFont := StandardFonts buttonFont.
	aWindow
		addMorph: self buildList
		fullFrame: (LayoutFrame
			fractions: (0@0 corner: 1@0.5)
			offsets:(0@0 corner:0@0)).
	aWindow
		addMorph: toolbar
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@0.5)
			offsets:(0@0 corner:0@(btnFont height + 14))).
			
	self textArea: self buildTextArea.
	
	aWindow
		addMorph: self textArea
		fullFrame: (LayoutFrame
			fractions: (0@0.5 corner: 1@1)
			offsets:(0@(btnFont height + 14) corner:0@0)).! !

!FlatMessageListBrowser methodsFor: 'items addition' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
addTextArea: aWindow

	aWindow 
		addMorph: self textArea 
		frame: (0@0.5 corner: 1@1).	! !

!FlatMessageListBrowser methodsFor: 'keys' stamp: 'BenjaminVanRyseghem 6/20/2011 15:11'!
arrowKey: aCharacter from: aPluggableListMorph 
	
	selectedItem ifNil: [ ^ self ].
	aCharacter = $n
		ifTrue: [ ^ self browseSendersOfMessagesFrom: selectedItem ].
	
	aCharacter = $N
		ifTrue: [ ^ self browseUsers ].	
		
	aCharacter = $x
		ifTrue: [ ^ self removeMethod ].
		
	aCharacter = $b
		ifTrue: [ ^ selectedItem browse ].
		
	aCharacter = $v
		ifTrue: [ ^ self browseVersionsFrom: selectedItem ].
		
	aCharacter = $m
		ifTrue: [ self browseMessagesFrom: selectedItem ]! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'StephaneDucasse 5/14/2011 23:27'!
browseButtonAction 

	self browseSelectedItem! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
browseButtonLabel

	^'Browse'! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/2/2011 14:13'!
browseButtonState 

	^ selectedItem isNil.! !

!FlatMessageListBrowser methodsFor: 'private' stamp: 'StephaneDucasse 5/14/2011 23:15'!
browseImplementors

	self browseMessagesFrom: selectedItem! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'StephaneDucasse 5/14/2011 22:04'!
browseMethodFull
	| myClass |
	(myClass := self selectedClassOrMetaClass) ifNotNil:
		[Smalltalk tools browse: myClass realClass selector: self selectedMessageName]! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'StephaneDucasse 5/14/2011 23:26'!
browseSelectedItem 

	selectedItem ifNotNil: [ selectedItem browse ]! !

!FlatMessageListBrowser methodsFor: 'private' stamp: 'StephaneDucasse 5/14/2011 23:15'!
browseSenders
	
	self browseSendersOfMessagesFrom: selectedItem! !

!FlatMessageListBrowser methodsFor: 'keys' stamp: 'VeronicaUquillas 9/3/2011 20:23'!
browseUsers

	^ self browseClassRefsOf: selectedItem realClass! !

!FlatMessageListBrowser methodsFor: 'private' stamp: 'VeronicaUquillas 9/3/2011 20:45'!
browseVersions

	selectedItem isMethod
		ifTrue: [ self browseVersionsFrom: selectedItem compiledMethod ]
		ifFalse:[ self browseCommentVersionsOf: selectedItem ]! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
buildButtonBrowse
	
	^(PluggableButtonMorph 
		on: self 
		getState: #browseButtonState 
		action: #browseButtonAction 
		label: #browseButtonLabel)
		hResizing: #spaceFill! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/6/2011 16:32'!
buildButtonImplementors
	
	^(PluggableButtonMorph 
		on: self 
		getState: #implementorButtonState 
		action: #implementorButtonAction 
		label: #implementorButtonLabel)
		hResizing: #spaceFill! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/6/2011 16:33'!
buildButtonSenders
	
	^(PluggableButtonMorph 
		on: self 
		getState: #sendersButtonState 
		action: #sendersButtonAction 
		label: #sendersButtonLabel)
		hResizing: #spaceFill! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/3/2011 15:50'!
buildButtonVersion
	
	^(PluggableButtonMorph 
		on: self 
		getState: #versionButtonState 
		action: #versionButtonAction 
		label: #versionButtonLabel)
		hResizing: #spaceFill! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'StephaneDucasse 5/14/2011 22:23'!
buildList

	^ PluggableListMorph
		on: self
		list: #getList
		selected: #selectedItemIndex
		changeSelected: #selectedItemIndex:
		menu: #buildMenu:
		
		"
		keystroke: keyActionSel"
! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 6/20/2011 15:07'!
buildMenu: aMenuMorph
	^ aMenuMorph
		defaultTarget: self;
		add: 'Browse full (b)' action: #browseSelectedItem;
		add: 'Inspect method' action: #inspectSelectedItem;
		addLine;
		add: 'Remove method (x)' action: #removeMethod;
		add: 'Toggle break on entry' action: #toggleBreakOnEntry;
		addLine;
		add: 'Senders of... (n)'		action: #browseSenders;
		add: 'Implementors of... (m)'	action:	#browseImplementors;
		add: 'Users of... (N)' action: #browseUsers;
		add: 'Versions (v)'	action:	#browseVersions;
		yourself! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/2/2011 14:09'!
buildPreferenceDropList: aWindow

	^( UIManager default theme 
		newDropListIn: aWindow
		for:self				
		list: #getPreferencesList
		getSelected: #preference
		setSelected: #preference:
		getEnabled: nil
		useIndex: false 
		help: self preferenceHelpText) hResizing: #rigid; width: 150; yourself! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 9/7/2011 16:06'!
buildTextArea

	
	textArea := self textMorphClass
		on: self
		text: #textToDisplay
		accept: #compileMethod:
		readSelection: #highlightSearchedString
		menu: #msgPaneMenu:shifted:.
	textArea 
		font: StandardFonts codeFont;
		visible: false;
		askBeforeDiscardingEdits: true.
	^ textArea! !

!FlatMessageListBrowser methodsFor: 'items creation' stamp: 'BenjaminVanRyseghem 5/13/2011 13:38'!
buildToolbar: aWindow
	"create the buttons toolbar"
	
	| toolbar |
	toolbar := aWindow newToolbar: {
		self buildButtonBrowse.
		self buildButtonSenders.
		self buildButtonImplementors.
		self buildButtonVersion.
		self buildPreferenceDropList: aWindow}.
	^toolbar hResizing: #shrinkWrap! !

!FlatMessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 5/3/2011 10:48'!
byteCodeLabel

	^ 'Byte Code'! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'VeronicaUquillas 9/3/2011 20:22'!
compileMethod: aString

	| method class |
	self textArea hasUnacceptedEdits: false.
	method := self 
				getMethod: selectedItem
				ifAbsent: ["use the information from the tree"
					class := self selectedNode getClass.
					nil].
	method ifNotNil: [:m | class := m realClass].
	class compile: aString.! !

!FlatMessageListBrowser methodsFor: 'list' stamp: 'StephaneDucasse 5/16/2011 10:55'!
deleteFromMessageList: anItem

	self model removeMethodReference: anItem! !

!FlatMessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
diffLabel

	^'Diffs'! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'VeronicaUquillas 9/3/2011 20:35'!
displayIfByteCode: aMethodReference

	 | method |
	aMethodReference isMethod 
		ifTrue: [ method := aMethodReference compiledMethod ].
	method ifNotNil: [ :each | ^each method symbolic ].
	^self unvailableByteCodeLabel! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'StephaneDucasse 7/26/2011 14:03'!
displayIfDiff: aRGMethodDefinition

	^TextDiffBuilder
		 buildDisplayPatchFrom: ((self model priorVersionOfAMethod: aRGMethodDefinition) sourceCode) 
		to: (aRGMethodDefinition sourceCode) 
		inClass: (aRGMethodDefinition className)! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/2/2011 14:16'!
displayIfInfo: aMethodReference

	^ 'Last modification : 
		', (aMethodReference timeStamp asDateAndTime asTimeStamp asString)
! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 8/26/2011 14:28'!
displayIfSource: aMethodReference
		^ aMethodReference sourceCode.! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
displayIfVersion: aMessageListInspectableNode

	^'Version ', (self model versionOfAMethod: aMessageListInspectableNode item) asString! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 8/26/2011 17:55'!
displayInformationFrom: aMethodReference

	self preference = self sourceLabel
		ifTrue: [^ self displayIfSource: aMethodReference].
	self preference = self byteCodeLabel
		ifTrue: [^ self displayIfByteCode: aMethodReference].
	self preference = self infoLabel
		ifTrue: [	^ self displayIfInfo: aMethodReference].
	self preference = self diffLabel 
		ifTrue: [^ self displayIfDiff: aMethodReference].
	^ self error: 'Error in the drop list'! !

!FlatMessageListBrowser methodsFor: 'context methods' stamp: 'BenjaminVanRyseghem 6/10/2011 18:29'!
doItContext
	
	^ nil! !

!FlatMessageListBrowser methodsFor: 'context methods' stamp: 'StephaneDucasse 9/7/2011 21:46'!
doItReceiver
     
	^ (Smalltalk globals at: selectedItem theNonMetaParentName) ! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
environment

	^ self model environment! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/6/2011 16:02'!
forceAlphabeticalOrder

	^ forceAlphabeticalOrder ifNil: [ forceAlphabeticalOrder := true ].! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/6/2011 16:03'!
forceAlphabeticalOrder: aBoolean

	forceAlphabeticalOrder := aBoolean! !

!FlatMessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/16/2011 14:00'!
forceFirstSelection

	self getList ifNotEmpty: [ self selectedItemIndex: 1 ]! !

!FlatMessageListBrowser methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
format: aString

	| list size result |
	size := 0.
	list := aString subStrings: String cr.
	list do: [:line || addedCharacter tempSize|
		addedCharacter := ''.
		line first == $- ifTrue: [addedCharacter := '	'].
		tempSize := (addedCharacter, line) size.
		(tempSize > size) ifTrue: [size := tempSize]]! !

!FlatMessageListBrowser methodsFor: 'list' stamp: 'BenjaminVanRyseghem 5/6/2011 16:03'!
getList

	| list |
	list := self model methodReferenceList.
	self forceAlphabeticalOrder ifTrue: [ list := list sort ].
	^ list! !

!FlatMessageListBrowser methodsFor: 'private' stamp: 'VeronicaUquillas 9/3/2011 20:28'!
getMethod: aMessageListInspectableNode ifAbsent: aBlock

	| methodReference |
	methodReference := aMessageListInspectableNode .
	^ methodReference realClass methodDict
			at: methodReference name
			ifAbsent: aBlock.! !

!FlatMessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 5/3/2011 11:28'!
getPreferencesList

	^OrderedCollection new
		add: self sourceLabel;
		add: self byteCodeLabel;
		add: self diffLabel;
		add: self infoLabel;
		yourself.
! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/16/2011 14:17'!
highlightSearchedString
	
	| string interval firstIndex |
	textArea ifNil: [ ^ 0 to: 0 ].
	searchedString ifNil: [ ^ 0 to: 0 ].
	string := textArea text asString.

	(searchedString includes: $:)
		ifTrue: [ | list |
			list := searchedString subStrings: ':'.
			list size = 1
				ifTrue: [" binary selector "
					firstIndex := string findString: searchedString.
					interval := firstIndex to: (firstIndex+searchedString size-1)]
				ifFalse: [| lastIndex |
					firstIndex := string findString: list first,':'.
					lastIndex := string findString: list last,':' startingAt: firstIndex+ (list first size -1).
					interval := firstIndex to: (lastIndex + list last size)]]
		ifFalse: [
			" unary selector "
			firstIndex := string findString: searchedString.
			interval := firstIndex to: (firstIndex+searchedString size-1)].
	^ interval! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'StephaneDucasse 5/14/2011 23:15'!
implementorButtonAction 

	self browseImplementors! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/6/2011 16:32'!
implementorButtonLabel

	^'Implementors'! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/6/2011 16:32'!
implementorButtonState 

	^ selectedItem isNil.! !

!FlatMessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
infoLabel

	^'Change Date'! !

!FlatMessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/3/2011 15:57'!
initialExtent

	^  450@550! !

!FlatMessageListBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 5/9/2011 14:33'!
initialize

	super initialize.
	self preference: self getPreferencesList first.
	
	self registerToEvents.
	" not used yet, but will be used as soon as Announcements will be fully used "
	self registerToAnnouncements! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'StephaneDucasse 5/14/2011 22:11'!
inspectSelectedItem

	selectedItem ifNotNil: [selectedItem inspect]! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
isComment
	| node |
	node := self selectedNode.
	^(node isInspectable) & (node item = 'Comment'). ! !

!FlatMessageListBrowser methodsFor: 'events' stamp: 'BenjaminVanRyseghem 5/9/2011 14:58'!
methodEvent: anEvent
	
	anEvent isModified
		ifTrue: [ self methodModified: anEvent].
	anEvent isRemoved
		ifTrue: [ self methodRemoved: anEvent].! !

!FlatMessageListBrowser methodsFor: 'announcements' stamp: 'VeronicaUquillas 9/3/2011 20:05'!
methodModified: ann

	| ref |
	ref := self getList detect: [:any | (any realClass = ann oldItem realClass) and: [ any name = ann oldItem selector ]] ifNone: [ nil ].
	ref ifNotNil: [ | newRef |
			newRef := ann item methodReference.
			self model methodReferenceList remove: ref.
			self model addMethodReferenceSilently: newRef.
			selectedItem := newRef.
			self changed: #getList]! !

!FlatMessageListBrowser methodsFor: 'announcements' stamp: 'VeronicaUquillas 9/3/2011 20:16'!
methodRemoved: ann

	| ref |
	ref := self getList detect: [:any | (any realClass = ann item realClass) and: [ any name = ann item selector ]] ifNone: [ nil ].
	ref ifNotNil: [ | newRef |
			self deleteFromMessageList: ref.
			self changed: #getList]! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
model

	^model! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
model: aModel

	model := aModel.
	model
		when: #changed
		send: #updateView
		to: self.
! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
msgPaneMenu: aMenu shifted: shifted

	^ aMenu labels: 
'find...(f)
find again (g)
set search string (h)
do again (j)
undo (z)
copy (c)
cut (x)
paste (v)
paste...
do it (d)
print it (p)
inspect it (i)
explore it (I)
debug it
accept (s)
cancel (l)
implementors (m)
methods containing (E)
senders (n)' 
		lines: #(0 3 5 9 14)
		selections: #(find findAgain setSearchString again undo copySelection cut paste pasteRecent doIt printIt inspectIt exploreIt debugIt accept cancel implementorsOfIt methodSourceContainingIt sendersOfIt)! !

!FlatMessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/16/2011 14:00'!
openInWorld
	| win |
	win := StandardWindow new model: self.
	win title: self title.
	self addAllItems: win.
	win themeChanged.
	win openInWorld.
	self forceFirstSelection.
	self changed: #textToDisplay.
	^ win! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
preference

	^ preference! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 13:58'!
preference: anObject

	preference := anObject.
	self changed: #textToDisplay.! !

!FlatMessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
preferenceHelpText

	^'Choose way to show'! !

!FlatMessageListBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 5/9/2011 14:32'!
registerToAnnouncements

	"SystemAnnouncer announcer weak
		on: SystemMethodModifiedAnnouncement send: #methodModified: to: self;
		on: SystemMethodRemovedAnnouncement send: #methodRemoved: to: self."! !

!FlatMessageListBrowser methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 5/9/2011 14:35'!
registerToEvents

	SystemChangeNotifier uniqueInstance notify: self ofSystemChangesOfItem: #method using: #methodEvent:.! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'StephaneDucasse 5/16/2011 10:49'!
removeMethod
	"Remove the selected message from the system."
	
	| confirmation sel indexOfRemovedItem |
	sel := self selectedSelector.
	confirmation := self systemNavigation confirmRemovalOf: sel on: self selectedClassOrMetaClass.
	confirmation = 3
		ifTrue: [^ self].
	indexOfRemovedItem := self selectedItemIndex.
	self selectedClassOrMetaClass removeSelector: sel.
	"No need to explicitly remove the methodReference from the browser model since the model 
	updates itself."
	indexOfRemovedItem = 1
		ifFalse: [self selectedItemIndex: indexOfRemovedItem].	
	confirmation = 2
		ifTrue: [self systemNavigation browseAllCallsOn: sel]! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 13:13'!
searchedString

	^ searchedString! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 13:13'!
searchedString: aString

	searchedString := aString! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'VeronicaUquillas 9/3/2011 20:22'!
selectedClassOrMetaClass

	^ selectedItem 
		ifNil: [ nil ]
		ifNotNil: [ selectedItem realClass ]! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 14:00'!
selectedItemIndex
	"Returns the index of selected item. If no item is selected selects the first one."

	^ selectedItem 
		ifNil: [ 0 ]
		ifNotNil: [ self getList indexOf: selectedItem ]! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/16/2011 13:58'!
selectedItemIndex: anInteger

	selectedItem := self getList at: anInteger ifAbsent: [ nil ].
	self changed: #selectedItemIndex.
	self changed: #textToDisplay.
	self updateTextArea! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2011 22:31'!
selectedSelector

	^ selectedItem selector! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'StephaneDucasse 5/14/2011 23:22'!
sendersButtonAction 

	self browseSenders! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/6/2011 16:33'!
sendersButtonLabel

	^'Senders'! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/6/2011 16:33'!
sendersButtonState 

	^ selectedItem isNil.! !

!FlatMessageListBrowser methodsFor: 'droplist' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
sourceLabel

	^'Source'! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
textArea

	^ textArea! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 16:01'!
textArea: anObject

	textArea := anObject.
	self updateTextArea! !

!FlatMessageListBrowser methodsFor: 'private' stamp: 'StephaneDucasse 5/7/2011 18:16'!
textMorphClass

	^ PluggableTextMorph! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/2/2011 14:17'!
textToDisplay
	
	selectedItem isNil 
		ifFalse: [ ^self displayInformationFrom: selectedItem ].
	^nil! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/9/2011 13:00'!
title

	^ title ifNil: [ title := 'Messages List' ]! !

!FlatMessageListBrowser methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 5/3/2011 11:31'!
title: aString

	title := aString! !

!FlatMessageListBrowser methodsFor: 'menus' stamp: 'StephaneDucasse 5/14/2011 22:37'!
toggleBreakOnEntry
	"Install or uninstall a halt-on-entry breakpoint"

	| selectedMethod |
	self selectedClassOrMetaClass isNil ifTrue: [^self].
	selectedMethod := self selectedClassOrMetaClass >> self selectedSelector.
	selectedMethod hasBreakpoint
		ifTrue: [BreakpointManager unInstall: selectedMethod]
		ifFalse: [BreakpointManager 
					installInClass: self selectedClassOrMetaClass
					selector: self selectedSelector].! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'BenjaminVanRyseghem 5/2/2011 13:42'!
unvailableByteCodeLabel

	^'Byte code unavailable for this object'! !

!FlatMessageListBrowser methodsFor: 'text' stamp: 'AlainPlantec 8/26/2011 17:50'!
updateTextArea

	self textArea ifNil: [ ^ self ].
	(self selectedItemIndex isNil)
		ifTrue:  [ self textArea visible: false ]
		ifFalse: [  self textArea visible: true ]! !

!FlatMessageListBrowser methodsFor: 'display' stamp: 'BenjaminVanRyseghem 5/3/2011 10:47'!
updateView

	self changed: #getList.! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'StephaneDucasse 5/14/2011 23:25'!
versionButtonAction 

	self browseVersions! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/3/2011 15:51'!
versionButtonLabel

	^'Versions'! !

!FlatMessageListBrowser methodsFor: 'buttons behavior' stamp: 'BenjaminVanRyseghem 5/3/2011 15:51'!
versionButtonState 

	^ selectedItem isNil.! !

Object subclass: #ChangeFileReader
	instanceVariableNames: 'file changeList list listIndex listSelections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

!ChangeFileReader methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/6/2011 17:08'!
addItem: item text: text

	| cr |
	cr := Character cr.
	changeList addLast: item.
	list addLast: (text collect: [:x | x = cr ifTrue: [$/] ifFalse: [x]])! !

!ChangeFileReader methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2011 14:12'!
changeFile

	^ (SourceFiles at: 2)! !

!ChangeFileReader methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2011 17:13'!
changeList

	^ changeList! !

!ChangeFileReader methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/6/2011 17:12'!
scanCategory  
	"Scan anything that involves more than one chunk; method name is historical only"

	| itemPosition item tokens stamp anIndex |
	itemPosition := file position.
	item := file nextChunk.

	((item includesSubString: 'commentStamp:')
	or: [(item includesSubString: 'methodsFor:')
	or: [item endsWith: 'reorganize']]) ifFalse:
		["Maybe a preamble, but not one we recognize; bail out with the preamble trick"
		^ self addItem: (ChangeRecord new file: file position: itemPosition type: #preamble)
				 text: ('preamble: ' , item contractTo: 50)].

	tokens := Scanner new scanTokens: item.
	tokens size >= 3 ifTrue:
		[stamp := ''.
		anIndex := tokens indexOf: #stamp: ifAbsent: [nil].
		anIndex ifNotNil: [stamp := tokens at: (anIndex + 1)].

		tokens second == #methodsFor:
			ifTrue: [^ self scanCategory: tokens third class: tokens first
							meta: false stamp: stamp].
		tokens third == #methodsFor:
			ifTrue: [^ self scanCategory: tokens fourth class: tokens first
							meta: true stamp: stamp]].

	tokens second == #commentStamp:
		ifTrue:
			[stamp := tokens third.
			self addItem:
					(ChangeRecord new file: file position: file position type: #classComment
									class: tokens first category: nil meta: false stamp: stamp)
					text: 'class comment for ' , tokens first, 
						  (stamp isEmpty ifTrue: [''] ifFalse: ['; ' , stamp]).
			file nextChunk.
			^ file skipStyleChunk].

	self assert: tokens last == #reorganize.
	self addItem:
		(ChangeRecord new
			file: file position: file position type: #reorganize
			class: tokens first category: nil meta: false stamp: stamp)
		text: 'organization for ' , tokens first, (tokens second == #class ifTrue: [' class'] ifFalse: ['']).
	file nextChunk! !

!ChangeFileReader methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/6/2011 17:14'!
scanCategory: category class: class meta: meta stamp: stamp

	| itemPosition method selector |
	[itemPosition := file position.
	method := file nextChunk.
	file skipStyleChunk.
	method size > 0]						"done when double terminators"
		whileTrue:
		[self addItem: (ChangeRecord new file: file position: itemPosition type: #method
							class: class category: category meta: meta stamp: stamp)
			text: 'method: ' , class , (meta ifTrue: [' class '] ifFalse: [' '])
				, ((selector := (Smalltalk globals at: class ifAbsent: [Object]) parserClass new parseSelector: method) isNil
					ifTrue: ['unparsableSelector']
					ifFalse: [selector])
				, (stamp isEmpty ifTrue: [''] ifFalse: ['; ' , stamp])]! !

!ChangeFileReader methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 5/6/2011 14:16'!
scanChangeFileFrom: start to: end

	self scanFile: self changeFile from: start to: end

	! !

!ChangeFileReader methodsFor: 'private' stamp: 'StephaneDucasse 9/7/2011 21:32'!
scanFile: aFile from: startPosition to: stopPosition
	
	file := aFile.
	changeList := OrderedCollection new.
	list := OrderedCollection new.
	listIndex := 0.
	file position: startPosition.
'Scanning ', aFile localName, '...'
	displayProgressFrom: startPosition to: stopPosition
	during: [:bar | | item prevChar itemPosition |
	[file position < stopPosition]
		whileTrue:
		[bar value: file position.
		[file atEnd not and: [file peek isSeparator]]
				whileTrue: [prevChar := file next].
		(file peekFor: $!!)
		ifTrue:
			[(prevChar = Character cr or: [prevChar = Character lf])
				ifTrue: [self scanCategory]]
		ifFalse:
			[itemPosition := file position.
			item := file nextChunk.
			file skipStyleChunk.
			item size > 0 ifTrue:
				[self addItem: (ChangeRecord new file: file position: itemPosition type: #doIt)
					text: 'do it: ' , (item contractTo: 50)]]]].
	listSelections := Array new: list size withAll: false! !

Object subclass: #MessageList
	instanceVariableNames: 'methodReferenceList versionsHistoryList useAsASet lastEntry sortingSelector environment dictionary sortedMethodReferencesList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

!MessageList commentStamp: 'BenjaminVanRyseghem 11/29/2010 11:31' prior: 0!
MessageList is a simple object that holds a set of ordered method definitions.
See MessageList example for an example.

MessageList example

Instance Variables:
	methodReferenceList	<Collection>!

!MessageList class methodsFor: 'example' stamp: 'sd 9/17/2011 16:46'!
example
	"self example"

	| oldSource newSource t1 t2 t3 ml mlb |
	oldSource := 'example1
	"This is the old version of the method"
	Transcript show: ''This is the old version of the method'' ;cr.'.

	newSource := 'example1
	"This is the new version of the method"
	Transcript show: ''This is the new version of the method'' ;cr.'.

	t1 := RGMethodDefinition
			realClass: MessageList class
			selector: #example.

	MessageList class compile: oldSource classified: 'example'.

	t2 := RGMethodDefinition 
			realClass: MessageList class
			selector: #example1.
		
	"here you can modify MessageList >> initialize to see the difference"
	MessageList class compile: newSource classified: 'example'.
		
	t3 := RGMethodDefinition 
			realClass: MessageList class
			selector: #example1.

	ml := MessageList new
			addMethodReference: t1;
			addMethodReference: t2;
			addMethodReference: t3.

	mlb := MessageListBrowser on: ml.

	mlb openInWorld! !

!MessageList class methodsFor: 'example' stamp: 'sd 9/17/2011 16:46'!
example1
	"This is the new version of the method"
	Transcript show: 'This is the new version of the method' ;cr.! !

!MessageList class methodsFor: 'toBeRemovedWithStringHolder' stamp: 'StephaneDucasse 9/17/2011 15:34'!
isPseudoSelector: aSelector
	"Answer whether the given selector is a special marker"
	self flag: #toRemoveWhenStringHolderIsGone.
	^ #(Comment Definition Hierarchy) includes: aSelector! !

!MessageList class methodsFor: 'instance creation' stamp: ''!
with: aCollection.

	^self new
		methodReferenceList: aCollection.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/6/2011 15:10'!
addFirstVersion

	| systemVersion date association |
	systemVersion := SystemVersion new date: '1 January 1901'.
	date := TimeStamp new.
	association := Association key: systemVersion value: date.
	self versionsHistoryList add: association.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:29'!
addMethodReference: aMethodReference

	self addMethodReferenceSilently: aMethodReference.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 5/9/2011 14:47'!
addMethodReference: aMethodReference at: index

	self addMethodReferenceSilently: aMethodReference at: index.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'VeronicaUquillas 8/26/2011 10:55'!
addMethodReferenceSilently: aMethodReference

	self useAsASet
		ifTrue: [ self methodReferenceList removeAllSuchThat: [:each | each fullName = aMethodReference fullName]].
	self checkCurrentHighestUpdate: aMethodReference.
	self methodReferenceList add: aMethodReference.
	lastEntry := aMethodReference.! !

!MessageList methodsFor: 'actions' stamp: 'VeronicaUquillas 8/26/2011 10:55'!
addMethodReferenceSilently: aMethodReference at: index

	self useAsASet
		ifTrue: [ self methodReferenceList removeAllSuchThat: [:each | each fullName = aMethodReference fullName]].
	self checkCurrentHighestUpdate: aMethodReference.
	self methodReferenceList at: index put:  aMethodReference.
	lastEntry := aMethodReference.! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
addVersion: anAssociation

	self versionsHistoryList add: anAssociation.
	self updateView! !

!MessageList methodsFor: 'building dictionary' stamp: 'VeronicaUquillas 9/1/2011 14:54'!
buildByClass
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| key value |
		key := each realClass.
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'VeronicaUquillas 8/31/2011 23:45'!
buildByDate: aBlock
	"Return an association where key is a Dictionary and value is the list sorted"

	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: aBlock.
	tempList do: [:each |
		| key1 key2 value |
		key1 := each timeStamp asDate.
		key2 := each realClass.
		value := each.		
		(result includesKey: key1)
			ifFalse: [result at: key1 put: Dictionary new].
		((result at: key1) includesKey: key2)
			ifFalse: [(result at: key1) at: key2 put: OrderedCollection new].
		((result at: key1) at: key2) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'VeronicaUquillas 9/1/2011 16:05'!
buildByPackage
	"Return an association where key is a Dictionary and value is the list sorted"

	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| class key1 key2 value |
		class := self environment classNamed: each theNonMetaClassName.
		key1 := class category.
		key2 := each actualClass.
		value := each.
			
		(result includesKey: key1)
			ifFalse: [result at: key1 put: Dictionary new].
		((result at: key1) includesKey: key2)
			ifFalse: [(result at: key1) at: key2 put: OrderedCollection new].
		((result at: key1)at: key2) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'building dictionary' stamp: 'BenjaminVanRyseghem 11/29/2010 10:11'!
buildByVersion
	"Return an association where key is a Dictionary and value is the list sorted"
	
	| result tempList |
	result := Dictionary new.
	tempList := self methodReferenceList copy sort: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	tempList do: [:each |
		| key value systemVersion |
		systemVersion := self findVersionOf: each.
		key := systemVersion version, ' - ',systemVersion highestUpdate asString..
		value := each.	
		(result includesKey: key)
			ifFalse: [result at: key put: OrderedCollection new].
		(result at: key) add: value].
	^(Association key: result value: tempList)! !

!MessageList methodsFor: 'private' stamp: ''!
byClassSelector

	^ #groupedByClass! !

!MessageList methodsFor: 'private' stamp: ''!
byDateAscendingSelector

	^ #groupedByDateAscending! !

!MessageList methodsFor: 'private' stamp: ''!
byDateDescendingSelector

	^ #groupedByDateDescending! !

!MessageList methodsFor: 'private' stamp: ''!
byPackageSelector

	^ #groupedByPackage! !

!MessageList methodsFor: 'private' stamp: ''!
byVersionSelector

	^ #groupedByVersion! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
checkCurrentHighestUpdate: aMethodReference

	| highestUpdate |
	highestUpdate := SystemVersion current highestUpdate.
	(self versionsHistoryList isEmpty or: [highestUpdate > self versionsHistoryList last key highestUpdate])
		ifTrue: [ 
			self addVersion: (Association key: SystemVersion current value: aMethodReference timeStamp)]! !

!MessageList methodsFor: 'actions' stamp: ''!
clearAll

	self methodReferenceList: OrderedCollection new.
	self updateView.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
dictionary
	dictionary ifNil: [self groupedByClass].
	^dictionary! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
dictionary: aDictionary

	dictionary := aDictionary! !

!MessageList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
environment

	^Smalltalk globals! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/10/2011 14:38'!
findIndexOfVersionOf: aMethodReference

	| list timeStamp|
	timeStamp := aMethodReference timeStamp.
	list := self versionsHistoryList.
	list size = 1
		ifTrue: [^1].
	1 to: list size - 1 do: [:i || current next |
		current := list at: i.
		next := list at: (i+1).
		((current value <= timeStamp asDateAndTime) & (next value asDateAndTime> timeStamp asDateAndTime))
			ifTrue: [^i]].
	^list size.! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
findVersionOf: aMethodReference

	| index |
	index := self findIndexOfVersionOf: aMethodReference.
	^(self versionsHistoryList at: index) key! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:32'!
groupedByClass
	"update the instance variable"
	
	self groupedByClassSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
groupedByClassSilently
	"update the instance variable"
	
	| association |
	association := self buildByClass.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byClassSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:10'!
groupedByDateAscending
	"update the instance variable"
	
	self groupedByDateAscendingSilently.
	self updateView.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
groupedByDateAscendingSilently
	"update the instance variable"
	
	| association |
	association := self buildByDate: [:m1 :m2 | m1 timeStamp <= m2 timeStamp].
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byDateAscendingSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:09'!
groupedByDateDescending
	"update the instance variable"
	
	self groupedByDateDescendingSilently.
	self updateView.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByDateDescendingSilently
	"update the instance variable"
	
	| association |
	association := self buildByDate: [:m1 :m2 | m2 timeStamp <= m1 timeStamp].
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byDateDescendingSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:09'!
groupedByPackage
	"update the instance variable"
	
	self groupedByPackageSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByPackageSilently
	"update the instance variable"
	
	| association |
	association := self buildByPackage.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byPackageSelector.! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 1/11/2011 14:10'!
groupedByVersion
	"update the instance variable"
	
	self groupedByVersionSilently.
	self updateView! !

!MessageList methodsFor: 'converting' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
groupedByVersionSilently
	"update the instance variable"
	
	| association |
	association := self buildByVersion.
	self dictionary: association key.
	self sortedMethodReferencesList: association value.
	self sortingSelector: self byVersionSelector.! !

!MessageList methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 11/29/2010 11:27'!
initialize 
	"Initialization"
	
	super initialize.
	useAsASet := false.
	methodReferenceList := OrderedCollection new.
	self clearAll.
	environment := self environment.
	versionsHistoryList := SortedCollection new sortBlock: [:a :b | a value < b value].
	self addFirstVersion.
	sortedMethodReferencesList := OrderedCollection new.! !

!MessageList methodsFor: 'private' stamp: 'StephaneDucasse 5/15/2011 18:01'!
isEmpty

	^ self methodReferenceList isEmpty! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByClass

	^ self  sortingSelector = self  byClassSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByDateAscending

	^self sortingSelector = self byDateAscendingSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:29'!
isSortedByDateDescending

	^self sortingSelector = self byDateDescendingSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
isSortedByPackage

	^self sortingSelector = self byPackageSelector
	! !

!MessageList methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:30'!
isSortedByVersion

	^self sortingSelector = self byVersionSelector
	! !

!MessageList methodsFor: 'accessing' stamp: ''!
lastEntry 

	^lastEntry! !

!MessageList methodsFor: 'accessing' stamp: ''!
level
		
	(self level2Selectors includes: (self sortingSelector))
		ifTrue: [^2].
	(self level3Selectors includes: (self sortingSelector))
		ifTrue: [^3].
	self error: 'The selector isn''t classified'! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
level2Selectors

	^#( #groupedByClass #groupedByVersion)! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 1/20/2011 15:51'!
level3Selectors

	^#( #groupedByDateAscending #groupedByDateDescending #groupedByPackage).! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
methodReferenceList

	^ methodReferenceList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
methodReferenceList: anObject

	methodReferenceList := anObject! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 11/29/2010 11:27'!
openInWorld
	"opens the system window for recent messages"

	| browser |
	browser := MessageListBrowser on: self.
	browser openInWorld.! !

!MessageList methodsFor: 'method version' stamp: 'VeronicaUquillas 9/3/2011 20:26'!
priorVersionOfAMethod: aMethodReference

	| tempList |
	tempList := self methodReferenceList select:[:each | 
		(each className = aMethodReference className) & 
		(each name = aMethodReference name)].
	^ tempList detect: [:each | (self versionOfAMethod: each) = ((self versionOfAMethod: aMethodReference) -1)] ifNone: [aMethodReference].! !

!MessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 11/29/2010 11:28'!
reSort

	^ self perform: (self sortingSelector,'Silently') asSymbol! !

!MessageList methodsFor: 'actions' stamp: ''!
removeMethodReference: aMethodReference

	self methodReferenceList remove: aMethodReference.
	self updateView.! !

!MessageList methodsFor: 'actions' stamp: 'StephaneDucasse 5/15/2011 18:21'!
revertLastMethodSubmission
	"If the most recent method submission was a method change, revert
	that change, and if it was a submission of a brand-new method, 
	remove that method."
	
	"self new revertLastMethodSubmission"
	| changeRecords lastSubmission theClass theSelector |
	self  isEmpty ifTrue: [^ Beeper beep].
	lastSubmission := self  lastEntry.
	theClass := lastSubmission actualClass ifNil: [^ Beeper beep].
	theSelector := lastSubmission selector.
	changeRecords := theClass changeRecordsAt: theSelector.
	changeRecords isEmptyOrNil ifTrue: [^ Beeper beep].
	changeRecords size = 1
		ifTrue:
			["method has no prior version, so reverting in this case means removing"
			theClass removeSelector: theSelector]
		ifFalse:
			[changeRecords second fileIn].! !

!MessageList methodsFor: 'private' stamp: 'BenjaminVanRyseghem 5/3/2011 11:33'!
size

	^ self methodReferenceList size! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortedMethodReferencesList

	^sortedMethodReferencesList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortedMethodReferencesList: anObject

	sortedMethodReferencesList := anObject! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortingSelector

	sortingSelector ifNil: [^ #groupedByClass].
	^sortingSelector
	! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
sortingSelector: anObject

	sortingSelector := anObject.! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 1/11/2011 14:06'!
title
	
	^'Message List'! !

!MessageList methodsFor: '*RecentSubmissions-UI' stamp: 'BenjaminVanRyseghem 11/29/2010 10:56'!
updateView
	
	self changed: #sortingSelector.
	self changed: #sortedMethodReferencesList.
	self changed: #dictionary.
	self triggerEvent: #changed.! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
useAsASet

	^ useAsASet! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
useAsASet: anObject

	useAsASet := anObject.
	anObject 
		ifTrue: [	self methodReferenceList: ((self methodReferenceList reversed asSet) asOrderedCollection)].
	self updateView! !

!MessageList methodsFor: 'method version' stamp: 'VeronicaUquillas 9/3/2011 20:26'!
versionOfAMethod: aMethodReference

	| tempList |
	tempList := self methodReferenceList select: [:each | 
		(each className = aMethodReference className) & 
		(each name = aMethodReference name)].
	tempList := tempList sort: [:m1 :m2 | m1 timeStamp < m2 timeStamp].
	^ tempList indexOf: aMethodReference ifAbsent: [0]! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
versionsHistoryList

	^ versionsHistoryList! !

!MessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 11/29/2010 11:26'!
versionsHistoryList: anObject

	versionsHistoryList := anObject! !

!MessageList methodsFor: 'private' stamp: 'StephaneDucasse 5/15/2011 18:04'!
zork
	
	^ 34! !

MessageList subclass: #RecentMessageList
	instanceVariableNames: 'maxListSize'
	classVariableNames: 'UniqueInstance'
	poolDictionaries: ''
	category: 'RecentSubmissions-Core'!

RecentMessageList class
	instanceVariableNames: 'settingDropList'!

!RecentMessageList commentStamp: '<historical>' prior: 0!
RecentMessageList record and store all the changes and can show them by doing RecentMessageList openInWorld.!

RecentMessageList class
	instanceVariableNames: 'settingDropList'!

!RecentMessageList class methodsFor: 'events' stamp: ''!
classEvent: anEvent

	anEvent isAdded
		ifTrue: [ self uniqueInstance aClassHasBeenAdded: anEvent].
	anEvent isCommented
		ifTrue: [ self uniqueInstance aClassHasBeenCommented: anEvent].
	anEvent isModified
		ifTrue: [ self uniqueInstance aClassHasBeenModified: anEvent].
	anEvent isRecategorized
		ifTrue: [ self uniqueInstance aClassHasBeenRecategorized: anEvent].
	anEvent isRemoved
		ifTrue: [ self uniqueInstance aClassHasBeenRemoved: anEvent].
	anEvent isRenamed
		ifTrue: [ self uniqueInstance aClassHasBeenRenamed: anEvent].
	anEvent isReorganized
		ifTrue: [ self uniqueInstance aClassHasBeenReorganized: anEvent].! !

!RecentMessageList class methodsFor: 'cleanup' stamp: 'MarcusDenker 1/24/2011 13:19'!
cleanUp
	self allInstancesDo: [:rml| rml initialize].! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
event: anEvent
	"Hook for SystemChangeNotifier"

	anEvent itemKind = SystemChangeNotifier classKind
		ifTrue:[ self classEvent: anEvent].
	anEvent itemKind = SystemChangeNotifier methodKind
		ifTrue:[ self methodEvent: anEvent].! !

!RecentMessageList class methodsFor: 'setting' stamp: 'StephaneDucasse 11/26/2010 17:04'!
icon

	^ThemeIcons smallInfoIcon! !

!RecentMessageList class methodsFor: 'initialize' stamp: ''!
initialize
	self startUp! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
methodEvent: anEvent

	anEvent isAdded
		ifTrue: [ self uniqueInstance aMethodHasBeenAdded: anEvent].
	anEvent isCommented
		ifTrue: [ self uniqueInstance aMethodHasBeenCommented: anEvent].
	anEvent isModified
		ifTrue: [ self uniqueInstance aMethodHasBeenModified: anEvent].
	anEvent isRecategorized
		ifTrue: [ self uniqueInstance aMethodHasBeenRecategorized: anEvent].
	anEvent isRemoved
		ifTrue: [ self uniqueInstance aMethodHasBeenRemoved: anEvent].
	anEvent isRenamed
		ifTrue: [ self uniqueInstance aMethodHasBeenRenamed: anEvent].
	anEvent isReorganized
		ifTrue: [ self uniqueInstance aMethodHasBeenReorganized: anEvent].! !

!RecentMessageList class methodsFor: 'instance creation' stamp: ''!
new
	^ self uniqueInstance! !

!RecentMessageList class methodsFor: '*RecentSubmissions-UI' stamp: 'StephaneDucasse 5/15/2011 17:56'!
openInWorld
	
	self flag: #ben. "I do not understand why recentMessageList = the domain object can openInWorld- sd"
	self uniqueInstance openInWorld.! !

!RecentMessageList class methodsFor: 'setting' stamp: 'BenjaminVanRyseghem 3/20/2011 01:30'!
recentMessageListMenuOn: aBuilder 
	<worldMenu> 
	
	(aBuilder item: #'Recent Messages')
		action: [self openInWorld];
		parent: #Tools;
		help: 'Browse the last messages you''ve submitted';
		icon: self icon;
		order: 1.! !

!RecentMessageList class methodsFor: 'setting' stamp: 'BenjaminVanRyseghem 12/16/2010 15:43'!
recentMessageListSettingOn: aBuilder 
	<systemsettings>

	(aBuilder group: #recentMessageList)
		target: self;
		parent: #codeBrowsing;
		label: 'Recent Messages' translated;
		description: 'Settings related to the recent messages browser' translated;
		with: [
			(aBuilder setting: #maxListSize)
				target: self uniqueInstance;
				label: 'Maximum size of the methods list' translated;
				description: 'If negative or zero, the size will be infinite. Caution : It may slow down your system' translated.
			(aBuilder setting: #useAsASet)
				target: self uniqueInstance;
				label: 'Use as a Set' translated;
				description: 'If true, then the list will act as a Set' translated.]! !

!RecentMessageList class methodsFor: 'instance creation' stamp: 'StephaneDucasse 11/26/2010 17:05'!
resetUniqueInstance
	"Reset the singleton of the recentMessageBrowser model, so if you execute it you will lose all the history of the recent messages."
	"self resetUniqueInstance"
	
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self uniqueInstance.
	self uniqueInstance triggerEvent: #reset.
	UniqueInstance := nil.
	! !

!RecentMessageList class methodsFor: 'system startup' stamp: ''!
startUp
	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #event:.! !

!RecentMessageList class methodsFor: 'events' stamp: ''!
stopNotifications
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self! !

!RecentMessageList class methodsFor: 'instance creation' stamp: ''!
uniqueInstance

	UniqueInstance ifNil: [UniqueInstance := super new].
	^UniqueInstance! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenAdded: anEvent! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenCommented: anEvent

	anEvent newStamp notNil
		ifTrue:[self addMethodReference: (self createAClassReference: anEvent)]! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenModified: anEvent
! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenRecategorized: anEvent
! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aClassHasBeenRemoved: anEvent

	self removeAClass: anEvent! !

!RecentMessageList methodsFor: 'class event handler' stamp: 'StephaneDucasse 7/26/2011 14:22'!
aClassHasBeenRenamed: anEvent

	| toChangeList |
	toChangeList := self methodReferenceList select: [:each | each className = anEvent oldName asSymbol].
	toChangeList do: [:each | each parentName: anEvent newName asSymbol].
	self updateView.! !

!RecentMessageList methodsFor: 'class event handler' stamp: ''!
aClassHasBeenReorganized: anEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aMethodHasBeenAdded: aMethodEvent

	self addMethodReference: (self createTheMethodReference: aMethodEvent)
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenCommented: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenModified: aMethodEvent

	self addMethodReference: (self createTheMethodReference: aMethodEvent)
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenRecategorized: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: 'BenjaminVanRyseghem 11/29/2010 11:25'!
aMethodHasBeenRemoved: aMethodEvent

	self removeAMethod: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenRenamed: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenReorganized: aMethodEvent
! !

!RecentMessageList methodsFor: 'method event handler' stamp: ''!
aMethodHasBeenhanged: aMethodEvent

! !

!RecentMessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:53'!
addMethodReference: aMethodReference.

	self addMethodReferenceSilently: aMethodReference.
	self checkSize.
	self updateView! !

!RecentMessageList methodsFor: 'actions' stamp: 'BenjaminVanRyseghem 12/16/2010 15:57'!
checkSize

	| result |
	result := false.
	self maxListSize > 0 "0 means infinite"
		ifTrue: [
			result := (self methodReferenceList size > self maxListSize).
			[self methodReferenceList size > self maxListSize]
				whileTrue: [self methodReferenceList removeFirst]].
	^result! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'VeronicaUquillas 8/26/2011 10:35'!
createAClassReference: aCommentedEvent

	^RGCommentDefinition realClass: aCommentedEvent item! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'VeronicaUquillas 8/24/2011 16:18'!
createARemovalMethodReference: aRemovedEvent
	
	| method |
	method := aRemovedEvent item.
	^ RGMethodDefinition
		realClass: method methodClass 
		selector: method selector! !

!RecentMessageList methodsFor: 'method reference creation' stamp: 'VeronicaUquillas 9/1/2011 08:51'!
createTheMethodReference: aModifiedMethodEvent
	
	| method |
	method := aModifiedMethodEvent item.
	^ (RGMethodDefinition
		realClass: method methodClass
		selector: method selector) asHistorical! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
defaultMaxListSize

	^100! !

!RecentMessageList methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
initialize

	super initialize.
	
	Smalltalk addToStartUpList: self class.! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:52'!
maxListSize

	maxListSize ifNil: [maxListSize := self defaultMaxListSize].
	^maxListSize! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 12/16/2010 15:55'!
maxListSize: aNumber

	maxListSize := (aNumber negative 
						ifTrue: [0]
						ifFalse:[aNumber]).
	self checkSize
		ifTrue: [self updateView]! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 7/26/2011 14:22'!
removeAClass: anEvent
	
	| tempList |
	tempList := self methodReferenceList select:[:each | each className = anEvent item name asSymbol].
	tempList do: [:each | self removeMethodReference: each]! !

!RecentMessageList methodsFor: 'private' stamp: 'VeronicaUquillas 9/1/2011 15:51'!
removeAMethod: aRemovedEvent
	
	| method list |
	method := aRemovedEvent item.
	list := (self methodReferenceList select: [:each |  
						each className = method methodClass name
							and:[ each name = method selector ]]).

	list do: [:each | 
			each fullName: (each className, '>>', each selector, ' (removed)') ].
	self updateView.! !

!RecentMessageList methodsFor: 'private' stamp: 'StephaneDucasse 11/26/2010 17:03'!
stringMethodRemoved

	^'This method have been removed'
	! !

!RecentMessageList methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 1/11/2011 14:07'!
title

	^'Recent Message List'! !
RecentMessageList initialize!
